        function FUMILIM(Ai,Hname,Np,exda,Lexda,Nexda,funct,Nit,ipr)

!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007

!--------------- Np(>0) - number of parameters, no upper restriction for this vaLue

!--------------- Ai: parameters array  Ai(Np,6) 
!--------------- Ai(i,1) initiaL vaLues of parameters before start of FUMILIM,
!---------------        finaL ones after finish of FUMILIM  (anaLog of common/A/A(100))
!--------------- Ai(i,2) Parameter errors after finish of FUMILIM  (anaLog of common/SIGMA/SIGMA(100))       
!--------------- Ai(i,3) CoreLLation factor after finish of FUMILIM  (anaLog of common/R/R(100))       
!--------------- Ai(i,4) Parameter step restrictin  (anaLog of common/PL/PL(100)),
!---------------         parameter fixed, if Ai(i,4)<0d0        
!--------------- Ai(i,5) Minimum aLLowed vaLue of Ai(i,1)        (anaLog of common/AL/AMN(100))       
!--------------- Ai(i,6) Maximum aLLowed vaLue of Ai(i,1)        (anaLog of common/AU/AMX(100))       

!--------------- hname: names for parameters array (character*(1-15)), dimension array(Np)
!--------------- Lazy user can write  hisq=FUMILIM(Ai,'*',Np,exda,Lexda,Nexda,funct,Nit,ipr),
!--------------- what means: no parameters names 

!--------------- exda: experimentaL points array exda(Lexda,Nexda), no upper restriction for Nexda 

!--------------- funct(x,a,df): user's function (shouLd be decLared as EXTERNAL in caLLing program,
!                where x(1:n) - arguments, a(1:Np) - fitted parameters, df(1:Np) - first derivatives,
!                user is free to define or not each df(i)
!                if funct(x,a,df) is Linear respectiveLy each a(i), user is free to define nothing in the Ai array,
!                and the task wiLL be soLved during 1 iteration (poLinomiaL fit, for exampLe)
!--------------- Nit: maximum aLLowed number of iteration

!--------------- ipr: a number, assosiated with fiLe name or screen(0,6) (use of '*' is impermissibLe)
!--------------- ipr < 0 : no print (for exampLe, during many track reconstruction)  

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	integer*2 indzma,indzma1
	parameter(rp=1d-17,ap=1d-37)
	character*(*) hname(Np)
	character*15 hnamein(Np)
      aLLocatabLe :: indm(:,:),z0(:),z(:)
	dimension g(Np),a(Np),da(Np),r(Np),sigma(Np)
      dimension pL(Np),amn(Np),amx(Np),indzma(Np),indzma1(Np)
	dimension indfrpar(Np),indfrpar1(Np),indboun(Np)
      dimension  indfix(Np),indderiv(Np),indderivi(Np)
	common/NEDm/NED(2)
	common/fumstat/nn1stat,nn2stat
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/z2par/z2(3)
	common/fuminput/eps,n1,n2,nparopt
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	common/fumpL/pLcom,pLcom2
	dimension exda(Lexda*Nexda)
	dimension Ai(Np,6)
      EXTERNAL funct

      if(np==2.and.ipr.Lt.0.and.Ai(1,4).ge.0d0.and.Ai(2,4).ge.0d0) then
         fumiLim=fumi2par(Ai,exda,Lexda,nexda,funct,Nit)
	   return
      endif

	ned(1)=nexda
	ned(2)=Lexda 
	ipri=ipr
      Niter=Nit
	niterc=Niter
	Npar=Np
	nfrpar=0
      do i=1,npar
	   a(i)=Ai(i,1)
	   if(Ai(i,5).eq.0d0) Ai(i,5)=-1d37
	   amn(i)=Ai(i,5)
	   if(Ai(i,6).eq.0d0) Ai(i,6)=1d37
	   amx(i)=Ai(i,6)
	   pL(i)=Ai(i,4)
	   if(pL(i).Lt.0d0) then
	      indfix(i)=3
         eLse
		  indfix(i)=0
		  nfrpar=nfrpar+1
		  indfrpar(nfrpar)=i
         endif
	   indboun(i)=0
	   da(i)=0d0
	   sigma(i)=0d0
	   R(i)=0d0
      enddo 
      nzfr=nfrpar*(nfrpar+1)/2
	nx=Lexda-2
	ifLgLo=2
	iendfLg=initfum(exda,a,amn,amx,indfrpar,indboun)  ! check user errors
	if(iendfLg.ne.0) return

      IF (ipri.ge.0) then
	     write(ipri,'(//)')
	     write(ipri,*) ' FunctionaL Minimization by FUMILIM Function'
		 write(ipri,*) 
     & 	 ' Here  EC: Expected Change in CHI^2/NDF During Next Step'
	     write(ipri,*) '       KAPPA: Estimated Distance to Minimum' 
           write(ipri,*) '       LAMBDA: Step Length Modifier'
	     write(ipri,'(/)')
		 write(ipri,*) ' Number of ExperimentaL Points', ned(1)
		 write(ipri,*) ' Iteration Limit is', niter
           hnamein='---------------'
	     if(hname(1).ne.'*') then
	        do i=1,npar
		       Lr=Len(hname(i))
	           if(Lr.gt.15) Lr=15
	           if(Lr.Lt.1) cycLe
			   do j=Lr,2,-1
                    if(hname(i)(j:j).ne.' ') exit
			   enddo	  			       
	           hnamein(i)(1:j)=hname(i)(1:j)
	        enddo
           endif
      endif

	caLL fumderiv(a,exda,funct,indfrpar,indderiv,indderivi) !find anaLyticaL derivatives
!---------------------- redefinition of pL(i)=0 
      npL=0
      do n=1,nfrpar
	   i=indfrpar(n) 
	   if(pL(i).eq.0d0) then
	      npL=npL+1
	      if(indderivi(i).ne.0d0) then
	         plt=pLcom2
            else
		     pLt=pLcom
		     if(indboun(i).ne.0) pLt=min(0.6d0*(amx(i)-amn(i)),pLt)
               if(pLt.eq.pLcom.and.a(i).ne.0d0) pLt=abs(a(i))+1d-6
            endif
	      pL(i)=pLt
         endif
      enddo
	if(npL.ne.0) write(ipri,*) npL,
     &'restrictions for parameter step are defined by FUMILIM'

      NN2=0
	aLLocate(Z0(NZfr),stat=ier1)
	aLLocate(Z(NZfr),stat=ier2)
      aLLocate(indm(Nfrpar,Nfrpar),stat=ier3)
	if((ier1+ier2+ier3).ne.0) then
	   write(ipri,*) '***FumiLim : fataL stop, ',
     *   'not enough memory for aLLocatabLe arrays'
	   stop
      endif
      caLL makeindm(indm,nfrpar)             ! make indexes for Z-matrix
	NDF=ned(1)-Nfrpar+1
!-----START NEW ITERATION

      DO iiter=0,Niter
	  iiterc=iiter
	  nfixboun=0
	  nfixindef=0

!-----REPEAT ITERATION WITH SMALLER STEP, when jump over extremum take pLace
      comp=1d0
      do nn1=1,n1                !  n1=2
	   if(ifLgLo.ne.1) then
	      caLL sgzm(exda,funct,Z0,g,a,pL,amx,indfrpar,indderiv)
         eLse
            CALL SGZm(exda,funct,Z,g,a,pL,amx,indfrpar,indderiv)  
         endif
	   hisqndf=hisq/ndf
         IF (Iiter.eq.0) exit
	   if(nn1.eq.n1) exit
!	   SP=rp*hisq      !   FUMILI version	 		 
         SP=1d-5*hisq    !-- in difference with FUMILI
         IF (ABS(hisq-oLdhisq)<SP.AND.-EC<SP.and.hisq<oLdhisq)  exit
         T=(hisq-oLdhisq-EC-EC)
         IF ((0.59D0*T+EC).Lt.0d0)                   exit
         T=-EC/T
	   comp=comp*0.25d0
         IF (T.Lt.comp) T=comp
         EC=EC*T
         NN2=0
	   nn1stat=nn1stat+1

         DO n=1,Nfrpar
	      i=indfrpar(n)
		  a(i)=a(i)-da(i)
            if(nn1.eq.1) PL(I)=PL(I)*T
            DA(I)=da(i)*T
            A(I)=A(I)+da(i)
         enddo
      enddo    ! nn1=1,n1 

      do  !------------------------ boundary check
      do  !------------------------ mgconv 

!--------REMOVE FROM Z CONTRIBUTION OF PARAMETERS, FIXED DUE TO BOUND OR INDEFINITE
       if(ifLgLo.ne.1) then
         Nfrpar1=0

         DO  n=1,Nfrpar
	     i=indfrpar(n)
           IF (indfix(I).ne.0) cycLe
           if(Z0(indm(n,n)).eq.0d0) then
	       indfix(i)=2
	       da(i)=0d0
		   nfixindef=nfixindef+1
		   cycLe
		 endif    

		 if(indboun(i).eq.1) then
             IF(AMX(I).LE.A(I).AND.G(I).Lt.0.D0.or.
     & 	   A(I).LE.AMN(I).AND.G(I).gt.0.D0) then
		     indfix(i)=1
			 da(i)=0d0
			 nfixboun=nfixboun+1
			 cycLe
             endif
           endif

           Nfrpar1=Nfrpar1+1
	     indfrpar1(Nfrpar1)=i
           k2=0 

           DO m=1,n
             IF (indfix(indfrpar(m)).ne.0) cycLe
		   k2=k2+1
             Z(indm(Nfrpar1,K2))=Z0(indm(N,m))
           enddo
         enddo ! n=1,Nfrpar

         if(iiter.eq.0.and.ifLgLo.eq.2.and.nfrpar.eq.nfrpar1) ifLgLo=1
      
	 endif   ! --------------------------------------------------- ifLgLo.ne.1
      
	 if(nfrpar1.gt.nparopt.and.ifLgLo.eq.1) then
          caLL mgconvopt(indm,z,r,indfix,indfrpar1,indzma,indzma1)
       eLse
          caLL mgconvm(indm,z,r,indfix,indfrpar1)
       endif
	 if(ifixindef.eq.0) exit  ! from mgconv cycLe
	   nfixindef=nfixindef+ifixindef
	   if(ifLgLo.eq.1) then
	      write(ipri,*)
     &  'Indefinite Parameters are Found, Optimization is Switched off'
		  ifLgLo=3
	   endif
      enddo  !------------------------ mgconv 

!-------CALCULATE THEORETICAL STEP TO MINIMUM and STEP CORRECTION FACTOR
        ALAMBD=1.D0
        AKAPPA=0.D0
        AFIX=0.D0   
        IFIX=0   
        DO i1=1,Nfrpar1
	     i=indfrpar1(i1)
	     sigma(i)=sqrt(Z(indm(i1,i1)))
	     dai=-G(indfrpar1(1))*Z(indm(i1,1))
		 do L1=2,Nfrpar1
               dai=dai-G(indfrpar1(L1))*Z(indm(i1,L1))
           enddo
	     absdai=abs(dai)
		 da(i)=dai
		 akap=absdai/sigma(i)
		 if(akap.gt.akappa) akappa=akap
	     pLi=pL(i)
!------------------CHECK FOR PARAMETERS ON BOUNDARY
		 if(indboun(i).eq.1) then
             IF (dai.Le.0) then
		      pLi=min(pLi,(a(i)-amn(i)))
             eLse
		      pLi=min(pLi,(amx(i)-a(i)))
             endif
             IF (pLi.Le.0.D0) then
                IF (AKAP.gt.AFIX) then   
                   AFIX=AKAP   
                   IFIX=I
                endif
			  cycLe   
		   endif   ! end check 	      
           endif  !(indboun(i)==1
	     aLam=pLi/absdai
	     if(aLam.lt.aLambd)aLambd=aLam
        enddo   !------------------------ theor step to minimum
	  if(ifix.eq.0) exit  ! from boundary check cycLe
        indfix(IFIX)=1
        nfixboun=nfixboun+1
      enddo   !------------------ boundary check 

!-----CALCULATE NEW CORRECTED STEP
      EC=0.D0
	amb=0.25/aLambd
      DO n=1,Nfrpar1
         i=indfrpar1(n)
	   absdai=abs(da(i))
	   reL=absdai/pL(i)
	   DA(I)=DA(I)*ALAMBD
         EC=EC+DA(I)*G(I)
	   IF (NN2.gt.N2.and.aLambd.Lt.0.5d0) then !-------  increase pL(I)
            if(rel.gt.amb) then
	         nn2stat=nn2stat+1
               PL(I)=PL(I)*4d0
	      endif
         endif
      enddo

!-----CHECK IF MINIMUM ATTAINED AND SET EXIT MODE
      ndifpar=nfrpar-nfrpar1 
      IF (-EC.Le.SP.and.NN1.ne.1.and.ALAMBD.Lt.1.D0) then ! no futher decrease
         iendfLg=6
      eLseif (AKAPPA.Lt.EPS) then !  good finish
         if(nfrpar.eq.0) then  ! aLL parameters are fixed
		    iendfLg=7
         eLseif(nfrpar1.eq.nfrpar) then  ! no bound or indef parameters
		    iendfLg=1
         eLseif(nfrpar1.eq.0) then  ! aLL par  are indef  or fixed parameters
		    if(nfrpar.eq.nfixboun) then
			   iendfLg=3         ! aLL par are on bound
            eLse
		       iendfLg=8
            endif
         eLseif(ndifpar.eq.nfixboun) then  ! there are bound parameters
		    iendfLg=2
         eLseif(nfixindef.gt.0) then   ! there are indef parameters
		    iendfLg=5
         endif
	  eLse                                  !--------  akappa>eps                                           
         if(nfrpar1.eq.0) then  ! no free parameters
		    iendfLg=8
         eLse 
		    if(iiter.eq.niter) iendfLg=4
         endif
      endif

      if(ipri.ge.0) CALL MONITm (hisqndf,hnamein,a,sigma,r,indfix)

      IF (iendfLg.ne.0) exit
	do n=1,nfrpar
	   i=indfrpar(n)
	   if(indfix(i).ne.0) then
	     indfix(i)=0
         eLse
	     a(i)=a(i)+da(i)
         endif
      enddo
      oLdhisq=hisq
      NN2=NN2+1

      ENDDO    !  iiter=0, niter
   
      fumiLim=hisqndf
      do i=1,npar
	   if(indfix(i).eq.1) then
            Ai(i,1)=a(i)*0.999d0
         else
            Ai(i,1)=a(i)
         endif
         Ai(i,2)=sigma(i)
         Ai(i,3)=R(i)
	   if(indfix(i).eq.2.and.ifLdoub.ne.0) then
	       Ai(i,4)=-1d0
         else
	       Ai(i,4)=pL(i)
	   endif
      enddo
	deaLLocate(Z0)
	deaLLocate(Z)
	deaLLocate(indm)
      RETURN
                END ! FumiLim

	          Block Data ! fumilim
      IMPLICIT REAL*8 (A-H,O-Z)
	common/fuminput/eps,n1,n2,nparopt
	common/fumdoub/fac
	common/fumpL/pLcom,pLcom2
	data fac/2.5d0/,pLcom/1d6/,pLcom2/1d12/
	data eps/0.01d0/,n1/6/,n2/1/,nparopt/30/
	        end
 
            function FUMI2par(Ai,exda,Lexda,nexda,funct,Nit)

!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(maxpar=2)
	parameter(rp=1d-17,ap=1d-37)
      EXTERNAL funct
	common/NEDm/NED(2)
      COMMON /G2par/G(2)/A2par/A(2)/PL2par/PL(2)
	common /R2par/R(2)/der2par/indderiv(2),indderivi(2)
      dimension indfix(2),SIGMA(2),DA(2),df(2)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/z2par/z2(3)
	common/fuminput/eps,n1,n2,nparopt
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	common/fumpL/pLcom,pLcom2
	dimension exda(Lexda*nexda),Ai(maxpar,6),indfrpar(2)

      Niter=Nit
	ipri=-1
	niterc=Niter
	ned(1)=nexda
	ned(2)=Lexda
	Npar=2
	Nfrpar=2
	nx=Lexda-2
      
	a(1)=Ai(1,1)
	a(2)=Ai(2,1)
!----------------------------- find defined derivatives
      k=3
	is=0
	indderivi(1)=0
	indderivi(2)=0
	df(1)=0d0
	df(2)=0d0
	Nnoderiv=0
      do i=1,ned(1)
        h=funct(exda(k),a,df)
	  do j=1,nfrpar
	     if(df(j).ne.0d0) then
		   if(indderivi(j).eq.0) then
		     indderivi(j)=1
	         is=is+1
             endif 
           endif 
        enddo
	  if(is.eq.nfrpar) exit
	  k=k+ned(2)
      enddo
	if(is.ne.nfrpar) then
         do i=1,nfrpar
            if(indderivi(i).eq.0) then
	        Nnoderiv=Nnoderiv+1
		    indderiv(Nnoderiv)=i
            endif 
         enddo
      endif 
!---------------------------- redefinition of pl(i)
	do i=1,2
	   pLt=Ai(i,4)
	   if(pLt.eq.0d0) then
	      if(indderivi(i).ne.0) then
		     pLt=pLcom2
            eLse
	         if(a(i).ne.0d0) then
		        pLt=abs(a(i))+1d-6
               else
	            pLt=plcom
		     endif
		  endif
         endif
	   pL(i)=pLt
      enddo

      NN2=0
      iendfLg=0
	NDF=ned(1)-1
	     
!-----START NEW ITERATION

      do iiter=0,Niter
	   iiterc=iiter

!-----REPEAT ITERATION WITH SMALLER STEP
      comp=1d0
      do nn1=1,n1   
	   caLL sgz2par(exda,funct)
	   hisqndf=hisq/ndf

         IF (Iiter.eq.0) exit
	   if(nn1.eq.n1) exit

         SP=1d-5*hisq
         IF (ABS(hisq-oLdhisq)<SP.AND.-EC<SP.and.hisq<oLdhisq)  exit
         T=(hisq-oLdhisq-EC-EC)
         IF ((0.59D0*T+EC).Lt.0d0)                   exit
         T=-EC/T
	   comp=comp*0.25d0
         IF (T.Lt.comp) T=comp
         EC=EC*T
         NN2=0

         DO i=1,2
 		  a(i)=a(i)-da(i)
            if(nn1.eq.1) PL(I)=PL(I)*T
            DA(I)=da(i)*T
            A(I)=A(I)+da(i)
         enddo
      enddo    ! nn1=1,n1 

      caLL mgconv2
      IF (ifixindef.ne.0) then
	    write(*,*) 'ridiculous event'
	    iendfLg=8
	    return
      endif

!-----CALCULATE THEORETICAL STEP TO MINIMUM and STEP CORRECTION
        aLambd=1d0
	  da(1)=-G(1)*Z2(1)-G(2)*Z2(2)
	  da(2)=-G(1)*Z2(2)-G(2)*Z2(3)
	  sigma(1)=sqrt(Z2(1))
	  sigma(2)=sqrt(Z2(3))
	  absda1=abs(da(1))
	  absda2=abs(da(2))
	  akappa=absda1/sigma(1)
	  akap2=absda2/sigma(2)
	  if(akap2.gt.akappa) akappa=akap2
	  AL1=pL(1)/absda1
	  if(AL1<aLambd) aLambd=AL1
	  AL2=pL(2)/absda2
	  if(AL2<aLambd) aLambd=AL2

       da(1)=da(1)*aLambd
       da(2)=da(2)*aLambd
       EC=da(1)*g(1)+da(2)*g(2)

      amb4=aLambd*4d0
      IF (NN2.gt.N2) then
	   if(AL1.lt.amb4) then
		  pL(1)=pL(1)*4d0
         endif
	   if(AL2.lt.amb4) then
	      pL(2)=pL(2)*4d0
         endif
      endif



!-----CHECK IF MINIMUM ATTAINED AND SET EXIT MODE
      IF (-EC.Le.SP.and.NN1.ne.1.and.ALAMBD.Lt.1.D0) then !no futher decrease
         iendfLg=1
      eLseif (AKAPPA.Lt.EPS) then !  good finish
		 iendfLg=1
	  eLse                                  !--------  akappa>eps                                           
		 if(iiter.eq.niter) iendfLg=4
      endif

      IF (iendfLg.ne.0) exit
	   do i=1,2
	      a(i)=a(i)+da(i)
         enddo
         oLdhisq=hisq
      NN2=NN2+1

      enddo    !  iiter=0, niter
      do i=1,2
        Ai(i,1)=a(i)
	  Ai(i,2)=sigma(i)
	  Ai(i,3)=r(i)
	  Ai(i,4)=pl(i)
      enddo
      fumi2par=hisqndf
      RETURN
                END ! Fumi2par


	   subroutine fumderiv(a,exda,funct,indfrpar,indderiv,indderivi)
!--------------------------- separation of analytical derivatives
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	common/glofum/iflglo,ipri,ifixindef
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
      common/NEDm/NED(2)
	dimension exda(*)
      dimension a(npar),indfrpar(nfrpar)
	dimension indderiv(npar),df(npar),indderivi(npar)
	character*80 frm
	data frm/'(" Defined Derivatives:"i5"  of"i5" Free Parameters")'/

      do i=1,npar
	  df(i)=0d0
        indderivi(i)=0
      enddo
      Nnoderiv=0
	npL=0
      k=3

	is=0
      do i=1,ned(1)
        h=funct(exda(k),a,df)
	  do n=1,nfrpar
	     j=indfrpar(n)
		 if(indderivi(j).eq.0) then
	        if(df(j).ne.0d0) then
		     indderivi(j)=1
	         is=is+1
             endif 
           endif 
        enddo
	  if(is.eq.Nfrpar) exit
	  k=k+ned(2)
      enddo

      if(ipri.ge.0) write(ipri,frm) is,Nfrpar
	if(is.eq.Nfrpar) return

      do n=1,nfrpar
         i=indfrpar(n)
         if(indderivi(i).eq.0) then
	     Nnoderiv=Nnoderiv+1
		 indderiv(Nnoderiv)=i
         endif
      enddo

      RETURN
                END ! Fumderiv

                   function initfum(exda,a,amn,amx,indfrpar,indboun)
!---------------  author: I.M. Sitnik, 2007

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/NEDm/NED(2)
	dimension exda(ned(2),ned(1))
	dimension a(*),amn(*),amx(*),indfrpar(*),indboun(*)

 	ifataL=0

	if(ned(2).Lt.3) then
        write(ipri,"(//'**** fumiLim: incorrect vaLue of Lexda=',i5//)")
     & 	 ned(2)
		 write(ipri,*)
     & 	 'Lexda - Length of one exp. point bLock: y,dy,x(1),x(2),...'
           write(ipri,*) 'shouLd be Lexda.gt.2'
		 ifataL=9
	     return
      endif

	do n=1,Nfrpar
	   i=indfrpar(n)
         if(amn(i).ge.amx(i)) then
		 write(ipri,
     &	 "('incorrect boundary condition for',i5,'th parameter: min='
     &     ,1pe12.4,'   max=',1pe12.4)")i,amn(i),amx(i)
		 write(ipri,*) 'shouLd be max > min'
		 ifataL=9
	   endif	   

	   if(amn(i).gt.-1d36.or.amx(i).Lt.1d36) then
	      ifLgLo=3
		  indboun(i)=1
		  if(a(i).Lt.amn(i)) then
		     a(i)=amn(i)+1d-36
		     write(ipri,
     &	     "('value of',i5,'th parameter shifted to down edge')") i
            endif
		  if(a(i).gt.amx(i)) then
		     a(i)=amx(i)-1d-36
		     write(ipri,
     &	     "('value of',i5,'th parameter shifted to up edge')") i
            endif
         endif
	enddo

	if((ned(1)-Nfrpar).Lt.0) then
         write(ipri,"(//'**** fumiLim: too few exp. points =',i5,
     & 	   '   shouLd be at Least Nexda=N(free)par'//)") ned(1)
	   ifataL=9
      endif

	if(ifataL.ne.0) then
	   write(ipri,"(/'***fumiLim: fataL initiaL conditions error'//)")
      endif

	initfum=ifataL
	return
               END   ! initfum

              SUBROUTINE SGZm(exda,funct,z,g,a,pl,amx,indfrpar,indderiv)
!---------------   author: I.N. Silin
!---------------  upgrade: I.M. Sitnik, 2007

!-----SUBROUTINE SGZ SETS UP CHI^2,G(GRADIENT OF S) AND
!-----Z(APPROXIMATE COVARIANCE MATRIX)
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(rp=1d-17,ap=1d-37)
      COMMON /NEDm/NED(2) !/X/X(20)
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fumoutput/hisq,iendflg,iiterc,akappa,alambd,EC
	dimension z(nzfr),g(npar),a(npar),pl(npar)
      dimension  indfrpar(nfrpar),indderiv(nfrpar)
	dimension df(npar),dfn(nfrpar),dummi(npar),hi(npar)
      dimension  x(nx),amx(npar)
	dimension exda(*)
	  external funct

      K2=0
      hisq=0d0
      Z(1:nzfr)=0d0
	do i=1,npar
         g(i)=0d0
	   df(i)=0d0
      enddo

	do n=1,Nnoderiv
	     i=indderiv(n)
           HIr=0.01d0*pl(i)
		 if((a(i)+HIr).gt.amx(i)) HIr=-HIr
		 HI(I)=HIr
      enddo

      DO L1=1,ned(1)
         y=funct(exda(k2+3),a,df)
         SIG=EXDA(K2+2)
         dysig=(Y-EXDA(K2+1))/sig
         hisq=hisq+dysig**2

	   do n=1,Nnoderiv
	      i=indderiv(n)
            AI=A(I)
            A(I)=AI+HI(i)
		  DF(I)=(FUNCT(exda(k2+3),a,dummi)-Y)/HI(i)
            A(I)=AI
         enddo

         L=0
         DO n=1,Nfrpar
		  i=indfrpar(n)
		  if(df(i).eq.0d0) then
		     DFn(n)=0d0
		  else    
               DFt=DF(i)/SIG
               DFn(N)=DFt
               G(i)=G(i)+DFt*dysig
		     do j=1,n
                  Z(L+j)=Z(L+j)+DFt*DFn(J)
               enddo
		     df(i)=0d0
		  endif
            L=L+n
	   enddo

         K2=K2+NED(2)
      enddo !  L1=1,ned(1)
      RETURN
               END        ! sgzm


               SUBROUTINE SGZ2par(exda,funct)
!---------------  author: I.M. Sitnik, 2007

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(maxpar=2)
 	parameter(rp=1d-17,ap=1d-37)
      COMMON /G2par/G(2)/A2par/A(2)/PL2par/PL(2)
	common /R2par/R(2)/der2par/indderiv(2)
      COMMON/NEDm/NED(2)
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/z2par/z(3)
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	dimension dummi(2),df(2),a2(2),hi(2)
	dimension exda(*)
	externaL funct

      K2=0
      hisq=0.D0
	g(1)=0d0
	g(2)=0d0
      Z(1)=0.D0
      Z(2)=0.D0
      Z(3)=0.D0
	hi(1)=pL(1)*0.01d0
	hi(2)=pL(2)*0.01d0

      DO L1=1,ned(1)
         df(1)=0d0
	   df(2)=0d0
         SIG=EXDA(K2+2)
	   y=funct(exda(k2+3),a,df)
         dysig=(Y-EXDA(K2+1))/sig
         hisq=hisq+dysig**2

	   do n=1,Nnoderiv
	      i=indderiv(n)
		  AI=A(i)
            A(i)=AI+HI(i)
		  df(i)=(FUNCT(exda(k2+3),a,dummi)-Y)/HI(i)
            A(i)=AI
         enddo

	   df1=df(1)/sig
	   df2=df(2)/sig
         G(1)=G(1)+df1*dysig
         G(2)=G(2)+DF2*dysig
         Z(1)=Z(1)+df1*df1
         Z(2)=Z(2)+df1*df2
         Z(3)=Z(3)+df2*df2
         K2=K2+NED(2)
      enddo !  L1=1,ned(1)

      RETURN
                   END

                   SUBROUTINE MONITm(hisqndf,hoL,a,sigma,r,indfix)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007

!-----ITERATION PROGRESS OUTPUT
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	  common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	  common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	  common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	  common/NEDm/NED(2)
	  dimension a(npar),sigma(npar),r(npar),indfix(npar)
	  character*80 formiter(2)
	data formiter(1)/
     *"(/3x'ITER='I3' EC='1pD11.4' kappa='D10.3' lambda='D10.3/)"/
      data formiter(2)
     */"(14x,'chi^2/NDF=',1pD11.4,6x,'chi^2=',D11.4/)"/
	character*9 hpar,hdev,hsta*8,hcor*11   
	data hpar/'PARAMETER'/,hsta/'STANDARD'/,hcor/'CORRELATION'/
	character*13 hnum,hval*5,hfac*6
	data hnum/'NUMBER & NAME'/,hval/'VALUE'/,hdev/'DEVIATION'/
	data hfac/'FACTOR'/
	character*105 ht(8,2)
	data ht(1,1)/"  MINIMISATION IS FINISHED SUCCESSFULLY"/
	data ht(1,2)/' '/
      data ht(2,1)/"  MINIMISATION IS FINISHED SUCCESSFULLY IN"/
	data ht(2,2)/"PART WHILE SOME PARAMETERS ARE FIXED ON BOUND"/
      data ht(3,1)/"  MINIMISATION IS TERMINATED:"/
	data ht(3,2)/"ALL PARAMETERS ARE FIXED ON BOUND"/
      data ht(4,1)/"  ITERATION LIMIT IS REACHED"/
	data ht(4,2)/" "/
      data ht(5,1)/"  MINIMISATION IS FINISHED SUCCESSFULLY IN PART"/
	data ht(5,2)/"WHILE SOME PARAMETERS ARE UNDEFINED"/
      data ht(6,1)/"  MINIMISATION IS TERMINATED AS NO FURTHER"/
	data ht(6,2)/"DECREASE IN CHISQ IS OBTAINABLE"/
      data ht(7,1)/" ALL PARAMETERS ARE FIXED"/
	data ht(7,2)/" "/
      data ht(8,1)/"  MINIMISATION IS TERMINATED AS ALL PARAMETERS"/
	data ht(8,2)/"EITHER FIXED ON BOUND OR HAVE INFINITE ERROR"/
	character*58 hformat(4)
	data hformat(1)/"(I12,1x,a15,1p3D17.5)"/      
      data hformat(2)/"(I12,1x,a15,1pD17.5,'  ON BOUND')"/
      data hformat(3)
     */"(I12,1x,a15,1pD17.5,6X,'INFINITE ERROR ESTIMATION')"/
      data hformat(4)/"(I12,1x,a15,1pD17.5,6X,'FIXED PARAMETER')"/
	character*(*) hoL(Npar)

	ECndf=EC/(ned(1)-Nfrpar+1)
      write(ipri,formiter(1)) Iiterc,ECndf,AKAPPA,ALAMBD
      write(ipri,formiter(2)) hisqndf,hisq
	write(ipri,'(9x,A9,16x,A9,8x,A8,9x,A11)')hpar,hpar,hsta,hcor
	write(ipri,'(9x,A13,12x,A5,12x,A9,8x,A6)') hnum,hval,hdev,hfac
      DO I=1,Npar
         ipr=indfix(i)+1
	   if(ipr.eq.1) then
	      write(ipri,hformat(ipr)) I,hoL(i),A(I),SIGMA(I),R(I)
	   eLse	 
	      write(ipri,hformat(ipr)) I,hoL(i),A(I)
         endif
	enddo

      IF (iendfLg.eq.0) return
	write(ipri,'(/"iendfLg=",I2,":",a49,a50/)')iendfLg,ht(iendfLg,1:2)
	return
               END

               subroutine mgconvm(indm,z,r,indfix,indfrpar1)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007
!---------------  Z-matrix transformation

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(rp=1d-17,ap=1d-37)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension indm(Nfrpar,Nfrpar)
	dimension z(nzfr),r(npar),indfix(npar),indfrpar1(nfrpar)
	dimension km(nfrpar),rc(nfrpar)
	equivaLence(n,Nfrpar1)
	   
      ifixindef=0
	IF (N.Lt.1) RETURN
	  	         
	Apn=ap*N
	apnrp=apn/rp
      APS=SQRT(1.d0/Apn)

      DO I=1,N  !------------------ cluster
         rc(I)=MAX(Z(indm(i,i)),APn)
      enddo ! i=1,n      !------------------ end cluster

      do j=1,n
        zcmi=1d+37
        do k=j,n
           zndmk=0.
           zkk=z(indm(k,k))
           zdk=sqrt(MAX(zkk,RP*ABS(rc(k)),rp*abs(zkk),APn))

		 do L=j,k-1
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zndmk) zndmk=abszkL
           enddo ! L=j,n
           do L=k+1,n
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zndmk) zndmk=abszkL
           enddo ! L=j,n

           temp=zndmk/zdk
           if(temp.Lt.zcmi) then
	        zcmi=temp
              i=k
           endif
        enddo ! k=1,n
        km(j)=i

        if(i.ne.j) then
!---------------------- Exchange i-th and j-th strings and coLumns of the matrix
           sav=z(indm(i,i))
           z(indm(i,i))=z(indm(j,j))
           z(indm(j,j))=sav  
           ri=rc(i)
           rc(i)=rc(j)
           rc(j)=ri

           do k=1,j-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=j+1,i-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=i+1,n
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

        endif ! i.ne.j  !-------------------End Exchange i-th and j-th ... 

        i=j
		ii=indm(i,i)
        zii=z(ii)
        rpn=rp*max(abs(rc(i)),abs(zII),apnrp) !

        IF(ZII.LE.RPn) then
          ZII=RPn
          rc(I)=-ABS(rc(I))
        endif

        zii=1.d0/sqrt(zii)
        arp=aps/zii !qz(i,i)
        ZiLMax=0d0
        AM=1d0

        DO L=1,i-1
            ZiL=ABS(Z(indm(L,i)))
            IF(ZiL.gt.ZiLMax) ZiLMax=ZiL
        enddo ! L=1,n
        DO L=i+1,N
            ZiL=ABS(Z(indm(i,L)))
            IF(ZiL.gt.ZiLMax) ZiLMax=ZiL
        enddo ! L=1,n
	  if(ZilMax.gt.arp) AM=arp/ZiLMax

        ZII=ZII*AM
        Z(ii)=ZII

        do L=n,i+1,-1   !------------------ cluster 
           iL=indm(i,L)
           Z(iL)=Z(iL)*ZII !
        enddo ! L=n,1,-1
        do L=i-1,1,-1
           iL=indm(i,L)
           Z(iL)=Z(iL)*ZII !
        enddo ! L=n,1,-1   !------------------ end cluster

        do k=n,i+1,-1
           ki=indm(k,i)
           C=Z(Ki) ! *qZ(I,I)

           do L=k,1,-1   !------------------ cluster
              Lk=indm(L,k)
              Z(Lk)=Z(Lk)-Z(indm(L,i))*C
           enddo ! L=k,1,-1  !------------------ end cluster

           Z(Ki)=-C*ZII ! -C
        enddo ! k=n,i+1,-1
      enddo ! j=1,n  ----------------------------------------------------

      DO I=1,N
         DO K=I,n      
            D=0d0
            DO L=k,n !------------------ cluster if to make array
               D=D+Z(indm(L,i))*Z(indm(L,k))
            enddo ! L=k,n   !------------------ end cluster
            Z(indm(k,i))=D
         enddo ! k=i,n
      enddo ! i=1,n  

      do i=n,1,-1
        j=km(i)
        if(j.ne.i) then
!-----------------------Exchange i-th and j-th strings and coLumns of the matrix
           sav=z(indm(i,i))
           z(indm(i,i))=z(indm(j,j))
           z(indm(j,j))=sav  
           ri=rc(i)
           rc(i)=rc(j)
           rc(j)=ri
           do k=1,i-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=i+1,j-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=j+1,n
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

       endif 
      enddo    ! i=n,1,-1 

      DO I=1,N
	   j=indfrpar1(i)
   	   absz=abs(Z(indm(i,i)))
	   absrc=abs(rc(i))
         IF(ABSZ>APS.AND.ABSrc>1d0.OR.ABSrc>APS.AND.ABSZ>1d0) then
            r(j)=rc(I)/ABSrc/AP
         eLse
            r(j)=absz*rc(I)
         endif
		 if(r(j).Lt.0d0) then
		    indfix(j)=2
              ifixindef=ifixindef+1
         endif
      enddo ! i=1,N

      RETURN
               end
       subroutine mgconvopt(indm,z,r,indfix,indfrpar1,indzma,indzma1)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007
!---------------  optimized Z-matrix transformation

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	integer*2 indzma,indzma1
	parameter(rp=1d-17,ap=1d-37)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	dimension indm(Nfrpar1,Nfrpar1),z(nzfr),r(npar)
      dimension  indfix(npar),indfrpar1(npar)
	dimension km(nfrpar),rc(nfrpar)
	dimension indzma(Nfrpar),indzma1(Nfrpar)
	equivaLence(n,Nfrpar1)
	   
      ifixindef=0
	  IF (N.Lt.1) RETURN
      if(iiterc.eq.0) then
	   do i=1,n
	      k=indm(i,i)
		  do j=i,n
		     if(z(k).ne.0) indzma(i)=j
		     k=k+j
		  enddo       
	   enddo
	endif
	  	         
	Apn=ap*N
	apnrp=apn/rp
      APS=SQRT(1.d0/Apn)

      DO I=1,N
        rc(I)=MAX(Z(indm(i,i)),APn) !  After Sgzm  aLL Z(ii) are aLways positive
      enddo ! i=1,n

      DO j=1,n
        zcmi=1d+37
        do k=j,n
           zndmk=0.
           zkk=z(indm(k,k))
           zdk2=MAX(zkk,RP*ABS(rc(k)),rp*abs(zkk),APn)
           zdk=sqrt(zdk2)

           do L=j,k-1
              abszkL=abs(z(indm(L,k)))
              if(abszkL.gt.zndmk) zndmk=abszkL
           enddo ! L=j,n

           do L=k+1,indzma(k)
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zndmk) zndmk=abszkL
           enddo ! L=j,n

           temp=zndmk/zdk
           if(temp.Lt.zcmi) then
	        zcmi=temp
              i=k
           endif
        enddo ! k=1,n
        km(j)=i

        if(i.ne.j) then
!---------------------- Exchange i-th and j-th strings and coLumns of the matrix
           sav=z(indm(i,i))
           z(indm(i,i))=z(indm(j,j))
           z(indm(j,j))=sav  
           ri=rc(i)
           rc(i)=rc(j)
           rc(j)=ri
           do k=1,j-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=j+1,i-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=i+1,n
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

        endif ! i.ne.j  !-------------------End Exchange i-th and j-th ... 

        i=j
	  ii=indm(i,i)
        zii=z(ii)
        rpn=rp*max(abs(rc(i)),abs(zII),apnrp)

        IF(ZII.LE.RPn) then
          ZII=RPn
          rc(I)=-ABS(rc(I))
        endif

        zii=1.d0/sqrt(zii)
        arp=aps/zii !qz(i,i)
        ZiLMax=0d0
        AM=1d0

        DO L=1,i-1
            ZiL=ABS(Z(indm(L,i)))
            IF(ZiL.gt.ZiLMax) ZiLMax=ZiL
        enddo ! L=1,n
        DO L=i+1,N
            ZiL=ABS(Z(indm(i,L)))
            IF(ZiL.gt.ZiLMax) ZiLMax=ZiL
        enddo ! L=1,n
	  if(ZilMax.gt.arp) AM=arp/ZiLMax

        ZII=ZII*AM
        Z(ii)=ZII

        do L=n,i+1,-1
           iL=indm(i,L)
           Z(iL)=Z(iL)*ZII !
        enddo ! L=n,1,-1
        do L=i-1,1,-1
           iL=indm(i,L)
           Z(iL)=Z(iL)*ZII !
        enddo ! L=n,1,-1

        do k=n,i+1,-1
           ki=indm(k,i)
           C=Z(Ki) ! *qZ(I,I)

           do L=k,1,-1 ! reaL z(n,i) - z(k+1,i) now are zeros
              Lk=indm(L,k)
              Z(Lk)=Z(Lk)-Z(indm(L,i))*C
           enddo ! L=k,1,-1

           Z(Ki)=-C*ZII ! -C
        enddo ! k=n,i+1,-1
      ENDDO ! j=1,n

      if(iiterc.eq.0) then
	   do n1=1,n
	      k=indm(n1,n1)
	      do n2=n1,n
	         if(Z(k).ne.0d0) indzma1(n1)=n2
		     k=k+n2
		  enddo       
	   enddo
      endif

      DO I=1,N
         DO K=I,indzma1(i)
            D=0d0
            DO L=k,indzma1(k) ! K,N
               D=D+Z(indm(L,i))*Z(indm(L,k))
            enddo ! L=k,n
            Z(indm(k,i))=D
         enddo ! k=i,n
      enddo ! i=1,n

      do i=n,1,-1
        j=km(i)
        if(j.ne.i) then
!-----------------------Exchange i-th and j-th strings and coLumns of the matrix
           sav=z(indm(i,i))
           z(indm(i,i))=z(indm(j,j))
           z(indm(j,j))=sav  
           ri=rc(i)
           rc(i)=rc(j)
           rc(j)=ri
           do k=1,i-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=i+1,j-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n
           do k=j+1,n
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n
       endif 
      enddo    ! i=n,1,-1 

      DO I=1,N
	   j=indfrpar1(i)
   	   absz=abs(Z(indm(i,i)))
	   absrc=abs(rc(i))
         IF(ABSZ>APS.AND.ABSrc>1d0.OR.ABSrc>APS.AND.ABSZ>1d0) then
            r(j)=rc(I)/ABSrc/AP
         eLse
            r(j)=absz*rc(I)
         endif
	   if(r(j).Lt.0d0) then
	      indfix(j)=2
            ifixindef=ifixindef+1
         endif
      enddo ! i=1,N

      RETURN
               end

               subroutine mgconv2
      IMPLICIT REAL*8 (A-H,O-Z)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common /z2par/z(3)/R2par/R(2)

      ifixindef=0
      zm1=Z(1)
      zm2=Z(2)
	  zm2q=zm2**2
	  zm3=Z(3)
	  if(zm1.Le.0d0.or.zm3.Le.0d0) then
	     ifixindef=2
		 return
      endif 

      det=zm3-zm2q/zm1
	if(det.Le.1d-19) det=1d-19
	z(3)=1d0/det
      z(1)=1d0/zm1+zm2q/zm1**2*z(3)
	z(2)=-zm2/zm1*z(3)

      r(1)=z(1)*zm1
      r(2)=r(1)

	  RETURN
                      end


                 function indmf(i,k)
	if(i.ge.k) then
        indmf=i*(i-1)/2+k
      eLse 
        indmf=k*(k-1)/2+i
      endif
      return
                     end

                  subroutine makeindm(indm,n)
      dimension indm(n,n)
	L=0   
 	   do i=1,N
	      do j=1,i
	         m=L+j
		     indm(j,i)=m
		     indm(i,j)=m
            enddo
		  L=L+i
	   enddo
      return
                     end



                   SUBROUTINE errexda(Ai,exda,funct,ipr)
!---------------  author: I.M. Sitnik, 2007
!--------------- output array "arr": dimension (ned(2),ned(1))
!--------------- arr(1,i) - contribution to chisq for i-exda-point
!--------------- arr(2,i) - error for function
!--------------- arr(3:ned(2),i) x-coordinates of i-exda-point
!--------------- ipr  -  fiLe associated number

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
!	parameter(rp=1d-17,ap=1d-37)
      COMMON /NEDm/ Ned(2)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension exda(ned(2),ned(1))
	dimension pL(npar),indfrpar(npar),df(npar),g(npar),r(npar)
	dimension Ai(npar,6),a(npar),amn(npar),amx(npar),dummi(npar)
	dimension x(nx),indfix(npar)
	dimension indderiv(npar),indderivi(npar)
	aLLocatabLe z(:),indm(:,:)
	externaL funct

      ipri=-1
      nfrpar=0
	do i=1,npar
         a(i)=Ai(i,1)
         pL(i)=Ai(i,4)
         amx(i)=Ai(i,6)
	   if(pL(i).Lt.0d0) cycLe
         nfrpar=nfrpar+1
	   indfrpar(nfrpar)=i
	enddo	  

      nfrpar1=nfrpar
      nzfr=nfrpar*(nfrpar+1)/2

	aLLocate(Z(NZfr))
      aLLocate(indm(Nfrpar,Nfrpar))
	caLL makeindm(indm,nfrpar)

!---------------------------CHI SQUARED
	caLL fumderiv(a,exda,funct,indfrpar,indderiv,indderivi)
      caLL sgzm(exda,funct,z,g,a,pL,amx,indfrpar,indderiv)
      caLL mgconvm(indm,z,r,indfix,indfrpar)

	write(ipr,'(10x"Y_th"6x"err_th"3x"Y_exp-Y_th   Chi**2"
     &9x"Y_exp"5x"sigma"8x"x(i)...")')

      DO j=1,ned(1)
         SIG=EXDA(2,j)
	   df=0d0
	   y=funct(exda(3,j),a,df)

         DO n=1,Nfrpar
            i=indfrpar(n)
	      if(indderivi(i).eq.0) then
               Amem=A(I)
               HI=0.01D0*pL(I)
               A(I)=Amem+HI
		     DF(I)=(FUNCT(exda(3,j),a,dummi)-Y)/HI
               A(I)=Amem
            endif 
         enddo
		 	 
         erfun=scaLm(z,df,indfrpar)
	   dif=exda(1,j)-y
	   hiq=(dif/sig)**2  
	   write(ipr,'(I5,1p4e11.3,3x,2e11.3,3x,7e11.3,9(/77x7e11.3))')
     &		  j,y,erfun,dif,hiq,exda(1:ned(2),j)
      enddo
	deaLLocate(Z)
      deaLLocate(indm)
      RETURN
                     END

           SUBROUTINE errfunct(aLim,bLim,nstep,Ai,exda,funct,ipr)
!---------------  author: I.M. Sitnik, 2007
!---------------  error-corridor for funct
!--------------- aLim:   min vaLue of x(ix)
!--------------- bLim:   max vaLue of x(ix)
!--------------- nstep:  number of points
!--------------- ipr  -  fiLe associated number


      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
      COMMON /NEDm/ Ned(2)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension exda(ned(2)*ned(1))
	dimension df(npar),g(npar),r(npar)
	dimension pL(npar),indfrpar(npar)
	dimension Ai(npar,6),a(npar)
	dimension dummi(npar),indfix(npar),amx(npar)
	dimension indderiv(npar),indderivi(npar)
	aLLocatabLe z(:),indm(:,:)
	externaL funct

      ipri=-1
      nfrpar=0

	do i=1,npar
         a(i)=Ai(i,1)
         pL(i)=Ai(i,4)
	   amx(i)=Ai(i,6)
	   if(pL(i).Lt.0d0) cycLe
         nfrpar=nfrpar+1
	   indfrpar(nfrpar)=i
	enddo	
	  
      nfrpar1=nfrpar
      nzfr=nfrpar*(nfrpar+1)/2

	if(ned(2).ne.3) then
	   write(ipr,*)
     &   'errfunct: this program works onLy with one-dimensionaL x'
	   return
      endif

	dx=(bLim-aLim)/(nstep-1)

	aLLocate(Z(NZfr))
      aLLocate(indm(Nfrpar,Nfrpar))
	caLL makeindm(indm,nfrpar)

	caLL fumderiv(a,exda,funct,indfrpar,indderiv,indderivi)
      caLL sgzm(exda,funct,z,g,a,pL,amx,indfrpar,indderiv)
      caLL mgconvm(indm,z,r,indfix,indfrpar)

      DO j=1,nstep
	   x=aLim+(j-1)*dx
	   df=0d0
	   y=funct(x,a,df)
          
         DO n=1,Nfrpar
            i=indfrpar(n)
	      if(indderivi(i).eq.0) then
               Amem=A(I)
               HI=0.01D0*pL(I)
               A(I)=Amem+HI
		     DF(I)=(FUNCT(x,a,dummi)-Y)/HI
               A(I)=Amem
            endif 
         enddo

         er=scaLm(z,df,indfrpar)
	   dw=y-er
	   up=y+er
	   write(ipr,'(1pe12.3,3x,3e12.4)') x,y,dw,up
      enddo
	deaLLocate(Z)
      deaLLocate(indm)
      RETURN
                     END

      SUBROUTINE errfmuLt(aLim,bLim,nstep,Ai,exda,funct,ix,x,ipr)
!---------------  author: I.M. Sitnik, 2007
!---------------  error-corridor for funct with more than one argument

!--------------- aLim:   min vaLue of x(ix)
!--------------- bLim:   max vaLue of x(ix), other x(i) shouLd be defined by user
!--------------- nstep:  number of points
!--------------- ipr  -  fiLe associated number

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
      COMMON /NEDm/ Ned(2)
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension exda(ned(2)*ned(1))
	dimension df(npar),g(npar),r(npar)
	dimension pL(npar),indfrpar(npar)
	dimension Ai(npar,6),a(npar),dummi(npar),x(nx)
	dimension xmem(nx),indfix(npar),amx(npar)
	dimension indderiv(npar),indderivi(npar)
	aLLocatabLe z(:),indm(:,:)
	externaL funct

      ipri=-1
      nfrpar=0
	do i=1,npar
         a(i)=Ai(i,1)
         pL(i)=Ai(i,4)
	   amx(i)=Ai(i,6)
	   if(pL(i).Lt.0d0) cycLe
         nfrpar=nfrpar+1
	   indfrpar(nfrpar)=i
	enddo	  

      nfrpar1=nfrpar
	nzfr=nfrpar*(nfrpar+1)/2
      ixr=ix

	if(ned(2).Le.3.or.ixr.gt.nx.or.ixr.Le.0) ixr=1
	dx=(bLim-aLim)/(nstep-1)
      xmem=x

	aLLocate(Z(NZfr))
      aLLocate(indm(Nfrpar,Nfrpar))
	caLL makeindm(indm,nfrpar)

	caLL fumderiv(a,exda,funct,indfrpar,indderiv,indderivi)
      caLL sgzm(exda,funct,z,g,a,pL,amx,indfrpar,indderiv)
      caLL mgconvm(indm,z,r,indfix,indfrpar)

      x=xmem
      DO j=1,nstep
	   x(ixr)=aLim+(j-1)*dx
	   df=0d0
	   y=funct(x,a,df)
          
         DO n=1,Nfrpar
            i=indfrpar(n)
	      if(indderivi(i).eq.0) then
               Amem=A(I)
               HI=0.01D0*pL(I)
               A(I)=Amem+HI
		     DF(I)=(FUNCT(x,a,dummi)-Y)/HI
               A(I)=Amem
            endif 
         enddo

         er=scaLm(z,df,indfrpar)
	   dw=y-er
	   up=y+er
	   write(ipr,'(1pe12.3,3x,3e12.4)') x(ixr),y,dw,up
      enddo
	deaLLocate(Z)
      deaLLocate(indm)
      RETURN
                     END

               function SCALm(Z,df,indfrpar)
!-----SUBROUTINE SCAL CALCULATES ER=VARIANCE OF THEORETICAL FUNCTION Y
!---------------   author: I.N. SiLin

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension Z(Nzfr),df(npar),indfrpar(npar)
 
      disper=0.D0
	do n=1,Nfrpar
	   i=indfrpar(n)
         df(n)=df(i)
      enddo
      DO  I=1,Nfrpar
      DO  L=1,Nfrpar
	    k=indmf(i,L)
         disper=disper+Z(K)*DF(I)*DF(L)
      enddo
      enddo
      scaLm=sqrt(disper)
      RETURN
                           END

			function fstrawd(x,a,df)
!---------------  author: I.M. Sitnik, 2007
!--------------- internaL function for tracks via straws

	impLicit reaL*8(a-h,o-z)
      dimension x(2),a(2),df(2)

      up=a(1)*x(1)+a(2)-x(2)
	dw=1d0+a(1)**2
	f=abs(up)/sqrt(dw)+1d-19
	up1=up*(dw*x(1)-a(1)*up)

	dw2=dw*f
	dw1=dw2*dw
	df(1)=up1/dw1
	df(2)=up/dw2

      fstrawd=f
	return
			end
	                     function fumstraw(as,bs,exda,nex)
!---------------  author: I.M. Sitnik, 2007
!--------------- user caLL for tracks via straws x=as*z+bs
!--------------- chisqndf=fumstraw(as,bs,exda), where
!                                 exda : input array of experimentaL points
!                                 exda(1,i): space radius (not time)
!                                 exda(2,i): error  
!                                 exda(3,i): z-coordinate of wire (aLong track) 
!                                 exda(4,i): x-coordinate of wire (transversaL to z)
!                                 shouLd be the same units for exda(1:4,i)
!                                 nex: number of experimentaL poits    
!   z-coordinate of 1st exp-point shouLd be Least, and of Last exp-point shouLd be Largest of vice versa  

	impLicit reaL*8(a-h,o-z)
	parameter(npar=2,Lexda=4)
	common/nparfum/Np,Nfrpar,Nfrpar1,Nzfr,nx,niterc
      dimension exda(Lexda,nex)
      dimension ab(2,6,4)
	externaL fstrawd

	x1=exda(3,1)
	dx=exda(3,nex)-x1

	y1=exda(4,1)
	dy=exda(4,nex)-y1
	r1=exda(1,1)
      r2=exda(1,nex)

!--------------------- make 4 sets of initiaL vaLues of parameters   
	dxq=dx**2
	dyq=dy**2
	dxdy=dx*dy

      c=r1+r2
	cq=c**2
	det=dxq+dyq-cq
	absdet=abs(det)+1d-37
	sqdet=sqrt(absdet)
      a1=(-dxdy-c*sqdet)/(cq-dx**2)
      a2=(-dxdy+c*sqdet)/(cq-dx**2)
	ab(1,1,1)=a1
	ab(1,1,2)=a2
	ab(2,1,1)=y1-a1*x1-r1*sqrt(1.+a1**2)
	ab(2,1,2)=y1-a2*x1+r1*sqrt(1.+a2**2)
	ab(1,4,1)=0.5d0
	ab(1,4,2)=0.5d0
	ab(2,4,1)=10.5d0
	ab(2,4,2)=10.5d0

      c=r2-r1
	cq=c**2
	det=dxq+dyq-cq
	sqdet=sqrt(det)
      a1=(-dxdy-c*sqdet)/(cq-dx**2)
      a2=(-dxdy+c*sqdet)/(cq-dx**2)
	ab(1,1,3)=a1
	ab(1,1,4)=a2
	ab(2,1,3)=y1-a1*x1+r1*sqrt(1.+a1**2)
	ab(2,1,4)=y1-a2*x1-r1*sqrt(1.+a2**2)
	ab(1,4,3)=0.5d0
	ab(1,4,4)=0.5d0
	ab(2,4,3)=10.5d0
	ab(2,4,4)=10.5d0
!---------------------------------------end of make.....
	hisqm=fumi2par(ab(1,1,1),exda,Lexda,nex,fstrawd,1)
	mbest=1

	hisqndf=fumi2par(ab(1,1,2),exda,Lexda,nex,fstrawd,1)
      if(hisqndf.Lt.hisqm) then
	   mbest=2
	   hisqm=hisqndf
	endif    

	hisqndf=fumi2par(ab(1,1,3),exda,Lexda,nex,fstrawd,1)
      if(hisqndf.Lt.hisqm) then
	   mbest=3
	   hisqm=hisqndf
	endif    

	hisqndf=fumi2par(ab(1,1,4),exda,Lexda,nex,fstrawd,1)
      if(hisqndf.Lt.hisqm) then
	   mbest=4
	   hisqm=hisqndf
	endif

	hisqndf=fumi2par(ab(1,1,mbest),exda,Lexda,nex,fstrawd,10)
      as=ab(1,1,mbest)
	bs=ab(2,1,mbest)   
      fumstraw=hisqndf
	return
	         end

	function Fumidoub(A,hname,Np,exda,Lexda,nexda,funct,Nit,IPR)
!---------------  author: I.M. Sitnik, 2007

!--------------- doubLe fit using FUMILIM with advanced remooving of "bad points" after the first fit
!--------------- parameter List identicaL with FUMILIM 

 	impLicit reaL*8(a-h,o-z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
      parameter(nh=100,ah=10d0,nexmax=1000)
	character*(*) hname(Np)
	common/NEDm/ned(2)
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	common/fumdoub/fac
	dimension hist(nh)
	aLLocatabLe histp(:,:) !,x(nx)
	dimension exda(Lexda,Nexda)
	dimension a(Np,6),dummi(Np),dummi2(Np)
	dimension a2(Np,2)
	dimension indfrpar1(Np)
	dimension Listbad(10)
	externaL funct

	write(ipr,*) '----- fumidoub: first fit using fumiLim -----'
      ifLdoub=1
      hisqndf=FUMILIM(A,hname,Np,exda,Lexda,nexda,funct,Nit,IPR)
	ifLdoub=0
	if(iendfLg==9) return
	if(iendfLg.eq.8) then
	   write(ipr,*) '----- fumidoub: second fit is senseLess -----'
	   return
      endif
	nfrpar1=0
	do i=1,np
	   if(a(i,4).gt.0d0) then
	     nfrpar1=nfrpar1+1
	     indfrpar1(nfrpar1)=i
         endif 
	enddo
	sig0=sqrt(hisqndf)

	caLL Fumisigm(A,hname,exda,funct,A2,IPR)  

      nexnw=0
	nbad=0
	if(nexda.Lt.nexmax) write(ipr,*)'-------- removed points:'
	do i=1,Nexda
	   dummi=0d0
         dummi2=0d0
	   ngood=0
	   y=funct(exda(3,i),a(1,1),dummi)
	   sig=exda(2,i)
	   do n=1,nfrpar1
	     j=indfrpar1(n)
           y2=derivnum(exda(3,i),a(1,1),dummi2,j,funct)

           if(y2.eq.y) then
	        ngood=ngood+1
           eLse
	        u=(exda(1,i)-y)/sig/sig0-a2(j,1)
		    cfac=abs(fac)*a2(j,2)/sig0
              if(abs(u).Le.cfac) ngood=ngood+1
            endif

         enddo
	   if(ngood.eq.nfrpar1) then
	      nexnw=nexnw+1
            exda(1:Lexda,nexnw)=exda(1:Lexda,i)
         eLse
	      if(nexda.Lt.nexmax) then
	         nbad=nbad+1
               Listbad(nbad)=i
	         if(nbad.eq.10) then
	            write(ipr,'(10i8)') Listbad
	            nbad=0
               endif
            endif
         endif 
      enddo

	if(nbad.gt.0.and.nbad.Lt.10) write(ipr,'(10i8)') Listbad(1:nbad)

      write(ipr,*) '----- fumidoub: second fit using fumiLim -----'
	write(ipr,*) '   '
	fumidoub=FUMILIM(A,hname,Np,exda,Lexda,nexnw,funct,Nit,IPR)
	nexda=nexnw
      return
	          end
	       Subroutine Fumisigm(A,hname,exda,funct,A2,IPR)
!---------------  author: I.M. Sitnik, 2008

 	impLicit reaL*8(a-h,o-z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
      parameter(nh=100,ah=10d0,nexmax=1000)
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	character*(*) hname(npar)
	character*15 hnamein(npar)
	common/NEDm/Nexda,Lexda
	common/gLofum/ifLgLo,ipri,ifixindef,ifLdoub
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	dimension hist(nh)
	aLLocatabLe histp(:,:) !,x(nx)
	dimension exda(Lexda,Nexda)
	dimension a(npar,6),dummi(npar),dummi2(npar)
	dimension a2(npar,2)
	dimension indfrpar1(npar)
	dimension Listbad(10)
	character*43 hformat
	data hformat/"(I12,1x,a15,1p3D17.5)"/
	character*9 hpar, hdis*12   
	data hpar/'PARAMETER'/,hdis/'DISTRIBUTION'/
	character*5 hval,hsig,hnum*13,hmea*12
	data hnum/'NUMBER & NAME'/hval/'VALUE'/
	data hmea/'MEAN-P.VALUE'/hsig/'SIGMA'/
	externaL funct

      hnamein='---------------'
	if(hname(1).ne.'*') then
	   do i=1,npar
	      Lr=Len(hname(i))
	      if(Lr.gt.15) Lr=15
	      if(Lr.Lt.1) cycLe
	      do j=Lr,2,-1
               if(hname(i)(j:j).ne.' ') exit
	      enddo	  			       
	      hnamein(i)(1:j)=hname(i)(1:j)
	   enddo
      endif
	nfrpar1=0
	do i=1,npar
	   if(a(i,4).Lt.0d0) then
	      a2(i,1)=0.
	      a2(i,2)=0.
         else
	     nfrpar1=nfrpar1+1
	     indfrpar1(nfrpar1)=i
         endif 
	enddo
      aLLocate(histp(nh,Nfrpar1),stat=ierr)
	if(ierr.ne.0) then
	   write(ipr,*) 'Fumidoub : not enough memory for aLLocatabLe array'
	   return
      endif

	ndf=nexda-npar
	sig0=sqrt(hisq/ndf)
	hist=0d0
	histp=0d0
	do i=1,nexda
	   dummi=0d0
         dummi2=0d0
	   y=funct(exda(3,i),a(1,1),dummi)
	   sigi=exda(2,i)
	   u=(exda(1,i)-y)/sigi/sig0
	   caLL dohist8(hist,nh,-ah,ah,u)
	   do n=1,nfrpar1
	      j=indfrpar1(n)
	      if(dummi(j).eq.0d0) then
               y2=derivnum(exda(3,i),a(1,1),dummi2,j,funct)
			 if(y.eq.y2) cycLe
            endif
		  caLL dohist8(histp(1,n),nh,-ah,ah,u)
         enddo
	enddo

	caLL hismom8(hist,nh,-ah,ah,amean,sig)
	do n=1,nfrpar1
	   j=indfrpar1(n)
	   caLL hismom8(histp(1,n),nh,-ah,ah,a2(j,1),a2(j,2))
	   a2(j,1)=a2(j,1)*sig0
	   a2(j,2)=a2(j,2)*sig0
	enddo

	write(ipr,*)'     FumiSigm:'
	write(ipr,'(9x,A9,16x,A9,8x,A12,5x,A12)') hpar,hpar,hdis,hdis
	write(ipr,'(9x,A13,12x,A5,12x,A12,5x,A5)') hnum,hval,hmea,hsig
	do i=1,npar
	   write(ipr,hformat)i,hnamein(i),a(i,1),a2(i,1),a2(i,2)
	enddo
      deaLLocate(histp)
      return
	          end
            subroutine dohist8(hist,nh,a,b,u)
 	impLicit reaL*8(a-h,o-z)
	dimension hist(nh)
      step=(b-a)/nh
	i=(u-a)/step+1
	if(i.gt.0.and.i.Le.nh) hist(i)=hist(i)+1d0
	return
	        end

            function derivnum(x,a,dummi,j,fun)
 	impLicit reaL*8(a-h,o-z)
      dimension a(*)
      amem=a(j)
      if(a(j).eq.0d0) then
         a(j)=0.1d0
      eLse
         a(j)=1.1*a(j)
      endif
      derivnum=fun(x,a,dummi)
      a(j)=amem
      return
            end

            subroutine hismom8(hist,nh,a,b,amean,sig)
 	impLicit reaL*8(a-h,o-z)
      dimension hist(nh) 
	hmax=0d0
	step=(b-a)/nh
	imax=0
	amean=0d0
	sig=1d+9

	do i=1,nh
	   if(hist(i).gt.hmax) then
	      imax=i
		  hmax=hist(i)
	   endif
	enddo
	if(imax.eq.0) return
	hmax1=hmax*0.135

	iend=nh
	do i=imax,nh
	   if(hist(i).Lt.hmax1) then
	      if(ifL.eq.1) then
		     iend=i-2
			 if(iend.Le.imax) iend=imax+1
			 exit
          eLse
		     ifL=1
          endif
       eLse
	      ifL=0
       endif
      enddo 

	ist=1
	do i=imax,1,-1
	   if(hist(i).Lt.hmax1) then
	      if(ifL.eq.1) then
		     ist=i+2
			 if(ist.ge.imax) ist=imax-1
			 exit
            eLse
		     ifL=1
            endif
         eLse
	      ifL=0
         endif
      enddo 

      sum=0d0
      sumq=0d0
	sn=0d0

	do i=ist,iend
	   u=a+(i-0.5)*step
       r=hist(i)
	   sn=sn+r
	   sum=sum+r*u 
	   sumq=sumq+r*u**2 
      enddo
	disp=(sumq-sum**2/sn)/sn
	if(disp.gt.0d0) then
         amean=sum/sn
	   sig=sqrt(disp)/0.879
      endif
	return
	        end

